import { simulateTransaction, } from '@project-serum/anchor/dist/cjs/utils/rpc';
class SimulateError extends Error {
    constructor(simulationResponse, message) {
        super(message);
        this.simulationResponse = simulationResponse;
    }
}
export async function simulate(tx, signers, commitment, includeAccounts) {
    tx.feePayer = this.wallet.publicKey;
    tx.recentBlockhash = (await this.connection.getLatestBlockhash(commitment !== null && commitment !== void 0 ? commitment : this.connection.commitment)).blockhash;
    const result = await simulateTransaction(this.connection, tx);
    if (result.value.err) {
        throw new SimulateError(result.value);
    }
    return result.value;
}
//# sourceMappingURL=anchor.js.map