/// <reference types="node" />
import { AccountInfo, PublicKey } from '@solana/web3.js';
import BN from 'bn.js';
import { I80F48, I80F48Dto } from './I80F48';
export declare class StubOracle {
    publicKey: PublicKey;
    group: PublicKey;
    mint: PublicKey;
    price: I80F48;
    lastUpdated: number;
    static from(publicKey: PublicKey, obj: {
        group: PublicKey;
        mint: PublicKey;
        price: I80F48Dto;
        lastUpdated: BN;
    }): StubOracle;
    constructor(publicKey: PublicKey, group: PublicKey, mint: PublicKey, price: I80F48Dto, lastUpdated: BN);
}
export declare function parseSwitcboardOracleV1(accountInfo: AccountInfo<Buffer>): number;
export declare function parseSwitcboardOracleV2(program: any, accountInfo: AccountInfo<Buffer>): number;
/**
 *
 * @param accountInfo
 * @returns ui price
 */
export declare function parseSwitchboardOracle(accountInfo: AccountInfo<Buffer>): Promise<number>;
export declare function isSwitchboardOracle(accountInfo: AccountInfo<Buffer>): boolean;
export declare function isPythOracle(accountInfo: AccountInfo<Buffer>): boolean;
